%if 0%{?fedora} || 0%{?rhel} == 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%define copying() \
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 7 \
%license %{*} \
%else \
%doc %{*} \
%endif

%global provider        github
%global provider_tld    com
%global project         golang
%global repo            appengine
# https://github.com/golang/appengine
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     google.golang.org/appengine
%global commit          1c3fdc51e1021e4822cf8475c97d3a14a2a6648e
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang-%{provider}-%{project}-%{repo}
Version:        0
Release:        0.3.git%{shortcommit}%{?dist}
Summary:        Go App Engine for Managed VMs
License:        ASL 2.0
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check}
BuildRequires: golang(github.com/golang/protobuf/proto)
BuildRequires: golang(golang.org/x/net/context)
%endif

Requires:      golang(github.com/golang/protobuf/proto)
Requires:      golang(golang.org/x/net/context)

Provides:      golang(%{import_path}) = %{version}-%{release}
Provides:      golang(%{import_path}/channel) = %{version}-%{release}
Provides:      golang(%{import_path}/datastore) = %{version}-%{release}
Provides:      golang(%{import_path}/delay) = %{version}-%{release}
Provides:      golang(%{import_path}/demos/guestbook) = %{version}-%{release}
Provides:      golang(%{import_path}/demos/helloworld) = %{version}-%{release}
Provides:      golang(%{import_path}/file) = %{version}-%{release}
Provides:      golang(%{import_path}/image) = %{version}-%{release}
Provides:      golang(%{import_path}/internal) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/aetesting) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/app_identity) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/base) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/channel) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/datastore) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/image) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/log) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/mail) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/memcache) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/modules) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/remote_api) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/search) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/taskqueue) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/urlfetch) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/user) = %{version}-%{release}
Provides:      golang(%{import_path}/internal/xmpp) = %{version}-%{release}
Provides:      golang(%{import_path}/log) = %{version}-%{release}
Provides:      golang(%{import_path}/mail) = %{version}-%{release}
Provides:      golang(%{import_path}/memcache) = %{version}-%{release}
Provides:      golang(%{import_path}/module) = %{version}-%{release}
Provides:      golang(%{import_path}/remote_api) = %{version}-%{release}
Provides:      golang(%{import_path}/search) = %{version}-%{release}
Provides:      golang(%{import_path}/taskqueue) = %{version}-%{release}
Provides:      golang(%{import_path}/urlfetch) = %{version}-%{release}
Provides:      golang(%{import_path}/user) = %{version}-%{release}
Provides:      golang(%{import_path}/xmpp) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test}
%package unit-test
Summary:         Unit tests for %{name} package
# If go_arches not defined fall through to implicit golang archs
%if 0%{?go_arches:1}
ExclusiveArch:  %{go_arches}
%else
ExclusiveArch:   %{ix86} x86_64 %{arm}
%endif
# If gccgo_arches does not fit or is not defined fall through to golang
%ifarch 0%{?gccgo_arches}
BuildRequires:   gcc-go >= %{gccgo_min_vers}
%else
BuildRequires:   golang
%endif

%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *.proto and generate devel.file-list
for file in $(find . -iname "*.proto") ; do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test.file-list
done
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%ifarch 0%{?gccgo_arches}
function gotest { %{gcc_go_test} "$@"; }
%else
%if 0%{?golang_test:1}
function gotest { %{golang_test} "$@"; }
%else
function gotest { go test "$@"; }
%endif
%endif

export GOPATH=%{buildroot}/%{gopath}:%{gopath}
gotest %{import_path}
gotest %{import_path}/channel
gotest %{import_path}/datastore
gotest %{import_path}/delay
# Dial hang took too long: 1.049004095s > 1s
#gotest %%{import_path}/internal
gotest %{import_path}/log
gotest %{import_path}/mail
gotest %{import_path}/memcache
gotest %{import_path}/module
gotest %{import_path}/remote_api
gotest %{import_path}/search
gotest %{import_path}/taskqueue
gotest %{import_path}/user
gotest %{import_path}/xmpp
%endif

%if 0%{?with_devel}
%files devel -f devel.file-list
%copying LICENSE
%doc README.md
%dir %{gopath}/src/google.golang.org
%dir %{gopath}/src/%{import_path}
%endif

%if 0%{?with_unit_test}
%files unit-test -f unit-test.file-list
%copying LICENSE
%doc README.md
%endif

%changelog
* Fri Jul 31 2015 jchaloup <jchaloup@redhat.com> - 0-0.3.git1c3fdc5
- Update spec file to spec-2.0
  resolves: #1249049

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.2.git1c3fdc5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Jan 22 2015 jchaloup <jchaloup@redhat.com> - 0-0.1.git1c3fdc5
- First package for Fedora
  resolves: #1185082
